/* keycodes.h
 * Copyright 2021 Steven Arnow <s@rdw.se>
 * 
 * This file is part of keyboard-dummy.
 * 
 * keyboard-dummy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * keyboard-dummy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with keyboard-dummy.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef KEYCODES_H_
#define	KEYCODES_H_

#define	USB_KBD_MOD_LCTRL	0x01
#define	USB_KBD_MOD_LSHIFT	0x02
#define	USB_KBD_MOD_LALT	0x04
#define	USB_KBD_MOD_LMETA	0x08
#define	USB_KBD_MOD_RCTRL	0x10
#define	USB_KBD_MOD_RSHIFT	0x20
#define	USB_KBD_MOD_RALT	0x40
#define	USB_KBD_MOD_RMETA	0x80

#define	USB_KBD_KEY_NONE	0
#define	USB_KBD_KEY_A		4
#define	USB_KBD_KEY_B		5
#define	USB_KBD_KEY_C		6
#define	USB_KBD_KEY_D		7
#define	USB_KBD_KEY_E		8
#define	USB_KBD_KEY_F		9
#define	USB_KBD_KEY_G		10
#define	USB_KBD_KEY_H		11
#define	USB_KBD_KEY_I		12
#define	USB_KBD_KEY_J		13
#define	USB_KBD_KEY_K		14
#define	USB_KBD_KEY_L		15
#define	USB_KBD_KEY_M		16
#define	USB_KBD_KEY_N		17
#define	USB_KBD_KEY_O		18
#define	USB_KBD_KEY_P		19
#define	USB_KBD_KEY_Q		20
#define	USB_KBD_KEY_R		21
#define	USB_KBD_KEY_S		22
#define	USB_KBD_KEY_T		23
#define	USB_KBD_KEY_U		24
#define	USB_KBD_KEY_V		25
#define	USB_KBD_KEY_W		26
#define	USB_KBD_KEY_X		27
#define	USB_KBD_KEY_Y		28
#define	USB_KBD_KEY_Z		29
#define	USB_KBD_KEY_1		30
#define	USB_KBD_KEY_2		31
#define	USB_KBD_KEY_3		32
#define	USB_KBD_KEY_4		33
#define	USB_KBD_KEY_5		34
#define	USB_KBD_KEY_6		35
#define	USB_KBD_KEY_7		36
#define	USB_KBD_KEY_8		37
#define	USB_KBD_KEY_9		38
#define	USB_KBD_KEY_0		39
#define	USB_KBD_KEY_ENTER	40
#define	USB_KBD_KEY_ESCAPE	41
#define	USB_KBD_KEY_BACKSP	42
#define	USB_KBD_KEY_TAB		43
#define	USB_KBD_KEY_SPACE	44
#define	USB_KBD_KEY_DASH	45
#define	USB_KBD_KEY_EQUALS	46
#define	USB_KBD_KEY_LBRACKET	47
#define	USB_KBD_KEY_RBRACKET	48
#define	USB_KBD_KEY_BSLASH	49
#define	USB_KBD_KEY_APO		50	// Apostrophe/asterisk on SWE keyboard
#define	USB_KBD_KEY_SEMICOLON	51
#define	USB_KBD_KEY_QUOTE	52
#define	USB_KBD_KEY_GRAVE	53
#define	USB_KBD_KEY_COMMA	54
#define	USB_KBD_KEY_POINT	55
#define	USB_KBD_KEY_FSLASH	56
#define	USB_KBD_KEY_CAPS_LOCK	57
#define	USB_KBD_KEY_F1		58
#define	USB_KBD_KEY_F2		59
#define	USB_KBD_KEY_F3		60
#define	USB_KBD_KEY_F4		61
#define	USB_KBD_KEY_F5		62
#define	USB_KBD_KEY_F6		63
#define	USB_KBD_KEY_F7		64
#define	USB_KBD_KEY_F8		65
#define	USB_KBD_KEY_F9		66
#define	USB_KBD_KEY_F10		67
#define	USB_KBD_KEY_F11		68
#define	USB_KBD_KEY_F12		69
#define	USB_KBD_KEY_PRNTSCR	70
#define	USB_KBD_KEY_SCROLL_LOCK	71
#define	USB_KBD_KEY_PAUSE	72
#define	USB_KBD_KEY_INSERT	73
#define	USB_KBD_KEY_HOME	74
#define	USB_KBD_KEY_PGUP	75
#define	USB_KBD_KEY_DELETE	76
#define	USB_KBD_KEY_END		77
#define	USB_KBD_KEY_PGDN	78
#define	USB_KBD_KEY_RARROW	79
#define	USB_KBD_KEY_LARROW	80
#define	USB_KBD_KEY_DARROW	81
#define	USB_KBD_KEY_UARROW	82
#define	USB_KBD_KEY_NUM_LOCK	83
#define	USB_KBD_KEY_KP_DIVIDE	84
#define	USB_KBD_KEY_KP_MULT	85
#define	USB_KBD_KEY_KP_MINUS	86
#define	USB_KBD_KEY_KP_PLUS	87
#define	USB_KBD_KEY_KP_ENTER	88
#define	USB_KBD_KEY_KP_1	89
#define	USB_KBD_KEY_KP_2	90
#define	USB_KBD_KEY_KP_3	91
#define	USB_KBD_KEY_KP_4	92
#define	USB_KBD_KEY_KP_5	93
#define	USB_KBD_KEY_KP_6	94
#define	USB_KBD_KEY_KP_7	95
#define	USB_KBD_KEY_KP_8	96
#define	USB_KBD_KEY_KP_9	97
#define	USB_KBD_KEY_KP_0	98
#define	USB_KBD_KEY_KP_DECIMAL	99
#define	USB_KBD_KEY_BAR		100 // Key next to left shift on reasonable keynoards
#define	USB_KBD_KEY_APP		101 // Menu/right click key?
#define	USB_KBD_KEY_POWER	102
#define	USB_KBD_KEY_KP_EQUALS	103
#define	USB_KBD_KEY_F13		104
#define	USB_KBD_KEY_F14		105
#define	USB_KBD_KEY_F15		106
#define	USB_KBD_KEY_F16		107
#define	USB_KBD_KEY_F17		108
#define	USB_KBD_KEY_F18		109
#define	USB_KBD_KEY_F19		110
#define	USB_KBD_KEY_F20		111
#define	USB_KBD_KEY_F21		112
#define	USB_KBD_KEY_F22		113
#define	USB_KBD_KEY_F23		114
#define	USB_KBD_KEY_F24		115
#define	USB_KBD_KEY_EXEC	116
#define	USB_KBD_KEY_HELP	117
#define	USB_KBD_KEY_MENU	118
#define	USB_KBD_KEY_SELECT	119
#define	USB_KBD_KEY_STOP	120
#define	USB_KBD_KEY_AGAIN	121
#define	USB_KBD_KEY_UNDO	122
#define	USB_KBD_KEY_CUT		123
#define	USB_KBD_KEY_COPY	124
#define	USB_KBD_KEY_PASTE	125
#define	USB_KBD_KEY_FIND	126
#define	USB_KBD_KEY_MUTE	127
#define	USB_KBD_KEY_VOL_UP	128
#define	USB_KBD_KEY_VOL_DOWN	129
#define	USB_KBD_KEY_LCAPSL	130
#define	USB_KBD_KEY_LNUML	131
#define	USB_KBD_KEY_LSCROLLL	132
#define	USB_KBD_KEY_KP_COMMA	133
#define	USB_KBD_KEY_KP_EQUAL2	134
#define	USB_KBD_KEY_INT1	135
#define	USB_KBD_KEY_INT2	136
#define	USB_KBD_KEY_INT3	137
#define	USB_KBD_KEY_INT4	138
#define	USB_KBD_KEY_INT5	139
#define	USB_KBD_KEY_INT6	140
#define	USB_KBD_KEY_INT7	141
#define	USB_KBD_KEY_INT8	142
#define	USB_KBD_KEY_INT9	143

#define	USB_KBD_KEY_MEDIA_PLYP	232
#define	USB_KBD_KEY_MEDIA_STOPC	233
#define	USB_KBD_KEY_MEDIA_PREV	234
#define	USB_KBD_KEY_MEDIA_NEXT	235
#define	USB_KBD_KEY_MEDIA_ELECT	236
#define	USB_KBD_KEY_MEDIA_VOLUP	237
#define	USB_KBD_KEY_MEDIA_VOLDN	238
#define	USB_KBD_KEY_MEDIA_MUTE	239
#define	USB_KBD_KEY_MEDIA_WWW	240
#define	USB_KBD_KEY_MEDIA_BACK	241
#define	USB_KBD_KEY_MEDIA_FRW	242
#define	USB_KBD_KEY_MEDIA_STOP	243
#define	USB_KBD_KEY_MEDIA_FIND	244
#define	USB_KBD_KEY_MEDIA_SCRLU	245
#define	USB_KBD_KEY_MEDIA_SCRLD	246
#define	USB_KBD_KEY_MEDIA_EDIT	247
#define	USB_KBD_KEY_MEDIA_SLEEP	248
#define	USB_KBD_KEY_MEDIA_COFFEE 249
#define	USB_KBD_KEY_MEDIA_RFRSH	250
#define	USB_KBD_KEY_MEDIA_CALC	251


#endif
